Status: Open

Priority: High

Assignee:

Category: Python bindings / sipify

Affected QGIS version:3.4.5 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 29214

Description

Hi devs,

I use qgis 3.4.5 with windows 7 64bit.

I build a qgsvectorlayer like this :

uri = qgis.core.QgsDataSourceUri()

uri.setDatabase('a_sqlite_file')

uri.setDataSource('', 'SELECT * FROM MyTable', 'geom' ,'','the_pk_column_name')

vlayer = qgis.core.QgsVectorLayer(uri.uri(), tablename, 'spatialite')

When I ask the id of the features in vlayer ([fet.id() for fet in vlayer.getFeatures()]), it returns the  value of the first column of 'MyTable', and

not the value of the 'the_pk_column_name' column...

it was working nicely in 2.18....

thank you in advance,

Related issues:

Duplicated by QGIS Application - Bug report # 21670: DB Manager - load sql qu... Closed 2019-03-25

History

#1 - 2019-03-01 08:06 PM - Giovanni Manghi

- Subject changed from Assigning a primary key in QgsDataSourceUri doesn't work :/ to Assigning a primary key in QgsDataSourceUri doesn't work

- Category changed from DB Manager to Python bindings / sipify

- Status changed from Open to Feedback

Have you asked in the developers mailing list if anything changed about what this is done in 3.*?

#2 - 2019-03-12 02:11 PM - Patrice V

Hi,

The moderator of the mailing list doesn't let me post a question... I really believe it is a bug and not an expected behaviour...

Regards,
#3 - 2019-03-12 02:13 PM - Giovanni Manghi

Patrice V wrote:

Hi,

The moderator of the mailing list doesn't let me post a question... I really believe it is a bug and not an expected behaviour...

Regards,

have you subscribed the list? if not is normal your messages get bumped.

#4 - 2019-03-14 10:52 AM - Patrice V

Hi, 

I've asked a subsription 2 weeks ago and I still not have a mail to confirm...

I'm sure it is a regression...

Regards,

#5 - 2019-03-14 12:47 PM - Giovanni Manghi

- Status changed from Feedback to Open

Patrice V wrote:

Hi, 

I've asked a subsription 2 weeks ago and I still not have a mail to confirm...

I'm sure it is a regression...

Regards,

the process to subscribe/unsubscribe the lists is not manually reviewed, you should receive an confirmation email, with a link.

#6 - 2019-03-20 06:08 PM - Patrice V

Hi, 

it's been 6 days I've made a post and nobody replies :(

it's blocking me for porting a plugin to qgis 3

What should I do ?

Thanks,

#7 - 2019-03-20 06:28 PM - Alessandro Pasotti

Patrice V wrote:

Hi, 

it's been 6 days I've made a post and nobody replies :(
it's blocking me for porting a plugin to qgis 3

What should I do ?

Perhaps you could get some useful ideas from this article:

https://nyalldawson.net/2016/08/how-to-effectively-get-things-changed-in-qgis/

#8 - 2019-03-25 02:57 PM - Alessandro Pasotti

- Duplicated by Bug report #21670: DB Manager - load sql query as layer with primary key added

2024-03-13 3/3

https://nyalldawson.net/2016/08/how-to-effectively-get-things-changed-in-qgis/

